/* dbgparse by Andrew "CHCNiZ" Learn 
 * Copyright © 2009 Andrew Learn
 *
 *  dbgparse is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  dbgparse is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with dbgparse.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>
#include <sys/types.h>

int parse_qb(unsigned char *buff, unsigned int len);
int find_end(unsigned char *buff,int len);

int main(int argc, char *argv[]) {
 unsigned char *chc,*p;
 unsigned char *buff;
 int flen;
 int end=0;
 int start=0;
 int len;
 int isend=0;
 int write_extra=0;
 int c;
 int dragdrop=0;
 int flags=0;
 char inname[1024*2],outname[1024*2]; //large yes but with drag and drop who knows how long people have their entire directories
 FILE *fdin,*fdout;
 struct stat file_stats;
 p=chc;
 printf("CHC's DBG converter\n");
if(argc==1) {
 printf("Enter the filename: \n");
 scanf("%s",inname);
 printf("Enter the file to save as: \n");
 scanf("%s",outname);
} else if(argc==2) { //someone dropped the file in(windows)
strcpy(inname,argv[1]);
strcpy(outname,argv[1]);
strcat(outname,".qb"); //TODO: remove the previous extension
} else {
strcpy(inname,argv[1]);
strcpy(outname,argv[2]);
}
if(stat(inname,&file_stats)) { 
 printf("Error checking size of %s are you sure it exists?\n",inname); 
 #ifdef WIN32
 system("PAUSE");
 #endif
 return -1; 
}
 buff=malloc(file_stats.st_size);
 fdin=fopen(inname,"rb");
	if(!fdin) {
	 printf("Couldn't open %s!\n",inname);
	 #ifdef WIN32
	 system("PAUSE");
 	 #endif
	 return -1; 
	}
 flen = fread(buff, 1, file_stats.st_size, fdin); //read file into memory
 chc=malloc(flen);
 memcpy(chc,buff,flen);
 fdout=fopen(outname,"wb");
	if(!fdout) {
	 printf("Couldn't open %s!\n",outname);
	 #ifdef WIN32
	 system("PAUSE");
	 #endif
	 return -1; 
	}
 len=parse_qb(buff,flen);
 fwrite(buff,len,1,fdout);
 fclose(fdout);
 printf("Finished!\n");
 #ifdef WIN32
 system("PAUSE");
 #endif
 return(0);
}
int parse_qb(unsigned char *buff, unsigned int len) {
 int nlen=len;
 int byte; //temporary storage for a byte
 int begin=0; //was [Checksums] found?
 unsigned char *p;
 char name[256]; //shouldn't be larger then this
 int end=0;//the string before \r\n
 int first=1;
 unsigned char *tmpbuff,*t;

 tmpbuff=malloc(len+1);
 t=tmpbuff;
 p=buff;
 for(nlen;nlen--;p++) {
	if(begin!=1) {
		if(!memcmp(p,"[Checksums]\r\n",13)) {
			begin=1;
		}
		} else {
			if(!memcmp(p,"0x",2)) {
				p+=2;//Skip 0x
				nlen-=2;
				sscanf(p,"%08x",&byte);
				p+=9;//hex plus space
				if(first==0) {
				memcpy(t,"\x00\x2B",2);t+=2;
				} else {
				memcpy(t,"\x01\x2B",2);t+=2;
				first=0;
				}
				memcpy(t,&byte,4);t+=4;
				byte=0;//clear it when finished
				end=find_end(p,nlen);
				if(end==0)break;//end of file
				strncpy(name,p,end);name[end]=0;
				memcpy(t,&name,end);t+=end;
				}
			}
}
 memcpy(t,"\x00\x00",2);t+=2;
 memcpy(buff,tmpbuff,t-tmpbuff);
 return t-tmpbuff;
}
int find_end(unsigned char *buff,int len) {

 unsigned char *p;
 p=buff;
 int len2=len;
	for(len2;len2--;p++) {
		if(!memcmp(p,"\r",1) || !memcmp(p,"\n",1)) {
			return len-len2-1;
		}
	}
 return 0;
}
